// Faan Tone Liu  01/16/02
// Bubble sort

#include <iostream>  // for i/o with cout and cin, and for writing to files
#include <fstream>   // for opening, reading from, writing to files

using namespace std;

// function prototypes
void print_array(const int[],int);  // displays all elements to screen
void bubble_sort(int[], int);       // sorts elements in array

// inputs a list of integers from a file, displays all elements to screen
// sorts the list, displays sorted list to screen, writes sorted list to file
// user is prompted for names of files
int main()
{
    const int maxelements(100);    // upper limit on size of list
    const int maxnamelen(80);      // upper limit on length of filename
    char infilename[maxnamelen];   // name user gives for input file
    char outfilename[maxnamelen];  // name user gives for output file
    int numelements(0);            // number of elements in list
    int arr[maxelements];          // list of integers
    ifstream infile;               // stream for input file
    ofstream outfile;              // stream for output file

    // get the file name, open the file
    do {
        cout << "Enter file name containing list (no more than 100 elements): ";
        cin >> infilename;
        if (infile.fail()) infile.clear();  // clear fail bit
        infile.open(infilename, ios::in);   // open input file
    } while (!infile.is_open());

    // read the list from the file into the array
    while (infile >> arr[numelements])
        numelements = numelements + 1;

    cout << "list elements before sorting: " << endl;
    print_array(arr, numelements);
    bubble_sort(arr, numelements);
    cout << "list elements after sorting: " <<endl;
    print_array(arr, numelements);

    // get the name of the output file, try to open it
    cout << "Enter name of file where sorted list will be stored: ";
    cin >> outfilename;
    outfile.open(outfilename, ios::out);
    if (!outfile.is_open()) {
        cout << "Sorry, unable to open file." << endl;
        return(1);
    }

    // write the numbers to the file
    for (int i=0; i < numelements; i++) {
        outfile << arr[i] << " ";
    }
    outfile << endl;

    // clean up
    infile.close();
    outfile.close();

    return 0;

}

// Display all array elements
void print_array(const int a[], int len)
{
    for (int i=0; i< len; i++)
        cout << a[i] << "  ";
    cout << endl;
}

// sort the array a in increasing order
// Make n passes through the list.  In each pass, compare adjacent pairs
// all the way along the array, switching if they're out of orders
void bubble_sort(int a[], int len)
{
	int i, j, temp;

    for (i=0; i < len-1; i++) {
        for (j = 0; j < len - i - 1; j++) {
            if (a[j] > a[j+1]) {
                temp = a[j+1];
                a[j+1] = a[j];
                a[j] = temp;
            }
        }
    }
}
